10 PROGNAME$ = "ADATCIRC -- Average Daily Access Time"
20 VERSION$ = "     Circular Orbits    June 14, 1991"
25 PRINT "Be patient, this program takes a while to run"
30 ' The author regrets that he cannot support or respond to questions about this code
40 'Satellite Identification Etc.
50    SAT$ = "RS-8 (1690 km)"
60    INCLINATION = 83      ' degrees
70    PERIOD = 119.1        ' minutes
80    ELEVATION = 0 'Satellite above this angle is in range
90    NSEG = 1000           'Number of segments per orbit
100      '
110 'CONSTANTS, CONVERSION FACTORS, FUNCTIONS, ETC.
120      DIM TOTTIME(20)
130      PI = 3.141593
140      RTOD = 180 / PI  'conversion factor, radians --> degrees
150      DTOR = PI / 180  'conversion factor, degrees --> radians
160      RE = 6371  'Mean radius of earth
170      DEF FNARCSIN (Z) = ATN(Z / SQR(1 - Z * Z))
180      DEF FNARCCOS (Z) = PI / 2 - ATN(Z / SQR(1 - Z * Z))
190      ELEV = ELEVATION * DTOR
200      SININCLIN = SIN(INCLINATION * DTOR)
210      HEIGHT = 331.25 * PERIOD ^ (2 / 3) - RE
220      'Calculate Beta (Surface distance in radians between ground
230             ' station and elevation circle)
240          BETA = FNARCCOS(COS(ELEV) * RE / (RE + HEIGHT)) - ELEV
250          COSBETA = COS(BETA)
260             '
270   FOR SEGG = 1 TO NSEG 'Loop through one orbit (perigee to perigee)<<<
280     'Calculate polar angle (ascending node to midpoint of segment)   ^
290          THETA = PI * (2 * SEGG - 1) / NSEG               '          ^
300     'Calculate latitude of SSP at midpoint of segment (SSPLAT)       ^
310          SSPLAT = FNARCSIN(SIN(THETA) * SININCLIN)       '           ^
320                                                          '           ^
330     FOR K = 0 TO 18   'Loop through ground station latitudes   <<<<  ^
340       GSLATITUDE = K * 5  ' ground station latitude in degrees    ^  ^
350       GSLAT = GSLATITUDE * DTOR                          '        ^  ^
360       IF ABS(GSLATITUDE) > 89.9 THEN GSLAT = GSLAT * .9999'       ^  ^
370       GOSUB 480  ' calculate probability factor (P) for segment   ^  ^
380       TOTTIME(K) = TOTTIME(K) + P * PERIOD / NSEG        '        ^  ^
390     NEXT K    '   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>^  ^
400                                                          '           ^
410   NEXT SEGG   '   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>^
420
430   GOSUB 570 ' Subroutine to print heading
440   FOR J = O TO 18: PRINT J * 5, TOTTIME(J) * 1440 / PERIOD: NEXT J
450
460 END   'ADATCIRC  M. DAVIDOFF, K2UBC
470   '
480 'Subroutine to find probability factor for each segment
490      ' logic only covers ground station latitudes >= 0
500    IF SSPLAT > (GSLAT + BETA) THEN P = 0: GOTO 550
510    IF SSPLAT < (GSLAT - BETA) THEN P = 0: GOTO 550
520    IF SSPLAT > PI - (GSLAT + BETA) THEN P = 1: GOTO 550
530    DL = FNARCCOS((COSBETA - SIN(GSLAT) * SIN(SSPLAT)) / (COS(GSLAT) * COS(SSPLAT)))
540    P = DL / PI' Probability of satellite being in range during segment
550 RETURN
560        '
570 'Subroutine to print heading
580 PRINT : PRINT PROGNAME$: PRINT VERSION$: PRINT
590 PRINT SAT$
600 PRINT "     inclination ="; INCLINATION; "degrees"
610 PRINT "     period ="; PERIOD; " minutes"
620 PRINT "     elevation cutoff ="; ELEVATION; "degrees"
630 PRINT "     number of segments used ="; NSEG
640 PRINT : PRINT
650 PRINT " Ground        Average      "
660 PRINT " Station       Daily Access "
670 PRINT " (deg N)       Time (min.)  "
680 PRINT
690 RETURN

