10 PROGNAME$ = "GCFEL -- Geometric Coverage Factor Ellipse"
20 VERSION$ = "      Eliptical Orbits  April 9, 1991"
30 ' The author regrets that he cannot support or respond to questions about this code
40 'Satellite Identification, Etc.
50    SAT$ = "AO-13 (G3RUH fall 1988 data)"
60    ECTY = .6563       ' (Eccentricity)
70    PERIOD = 686.7        ' minutes
80    MM = O    'Mean Motion (revs/day)
90    SMA = O    'Semimajor axis (kms)
100    IF SMA = O AND PERIOD = O THEN SMA = 331.25 * (1440 / MM) ^ (2 / 3)
110    IF SMA = O AND MM = O THEN SMA = 331.25 * PERIOD ^ (2 / 3)
120      '
130 'CONSTANTS, CONVERSION FACTORS, FUNCTIONS, ETC
140      PI = 3.141593
150      RTOD = 180 / PI  'conversion factor, radians --> degrees
160      DTOR = PI / 180  'conversion factor, degrees --> radians
170      RE = 6371 'Mean radius of earth
180      LR = SMA * (1 - ECTY * ECTY)'Latus rectum
190      K2 = SQR((1 + ECTY) / (1 - ECTY))
200      '
210  PRINT : PRINT PROGNAME$: PRINT VERSION$: PRINT SAT$
220  PRINT "    Eccentricity ="; ECTY
230  PRINT "    period ="; PERIOD
240  PRINT "    Mean motion ="; MM
250  PRINT "    Semimajor axis ="; SMA: PRINT
260  PRINT "mean anomaly", "height", "theta", "iterations", "GCF"
270     '
280 SUMGCF = O
290 FOR MA = O TO 180   'Loop through half orbit (perigee to apoggee)
300    EAINIT = PI * MA / 180
310    EA = EAINIT
320    FOR I = 1 TO 20
330      CORRECTION = (EA - EAINIT - ECTY * SIN(EA)) / (1 - ECTY * COS(EA))
340      EA = EA - CORRECTION
350      IF ABS(CORRECTION) < .0001 THEN GOTO 370
360    NEXT I
370    IF ABS(EA - PI) < .0001 THEN THETA = PI: GOTO 400
380    THETA = 2 * ATN(K2 * TAN(EA / 2))
390    IF THETA < O THEN THETA = THETA + 2 * PI
400    R = LR / (1 + ECTY * COS(THETA))
410    HEIGHT = R - RE
420    GCF = HEIGHT / R
430    IF MA > O AND MA < 180 THEN SUMGCF = SUMGCF + GCF * 2 ELSE SUMGCF = SUMGCF + GCF
440    PRINT MA, HEIGHT, THETA * RTOD, I, GCF
450 NEXT MA
460 PRINT
470 PRINT "average GCF ="; SUMGCF / 360
480 END  'GCFEL  (Geometric Coverage Factor Ellipse)

